<?php

function getint4mac($a,&$p){
	return (ord($a[$p++])<<24)+(ord($a[$p++])<<16)+(ord($a[$p++])<<8)+ord($a[$p++]);
}
function getint2mac($a,&$p){
	return (ord($a[$p++])<<8)+ord($a[$p++]);
}
function getstr($a,&$p,$len){
	$s=substr($a,$p,$len); $p+=$len; return $s;
}
function int22str($in){
	return chr($in&0xFF).chr(($in>>8)&0xFF);
}
function int42str($in){
	return chr($in&0xFF).chr(($in>>8)&0xFF).chr(($in>>16)&0xFF).chr(($in>>24)&0xFF);
}

function make_chunk($type,$data){
	if (strlen($type) !== 4) die("Error: Bad chunk type: \"$type\"");
	$length = strlen($data);
	return $type . int42str($length) . $data . (($length & 1) ? "\x00" : "");
}

function parse_WAVE($f){
	$p = 0;
	while ($p < strlen($f)){
		$chunk_type = getstr($f,$p,4);
		$chunk_size = getint4mac($f,$p);
		if ($chunk_type == "Cue#") {
			// skip over cue points
			$p += $chunk_size;
		} else if ($chunk_type == "Data") {
			$chunk = getstr($f,$p,$chunk_size);
			// wave data
			$chunk_p = 0;
			$sample_rate = getint2mac($chunk,$chunk_p);
			$wave_data_size = getint4mac($chunk,$chunk_p);
			$chunk_p += 14;
			assert($chunk_p + $wave_data_size == $chunk_size);
			$wave_data = getstr($chunk,$chunk_p,$wave_data_size);
			global $output_fn;
			$fp = fopen($output_fn.".wav","wb");
			if (!$fp) {
				die("Error: Can't open output file!");
			} else {
				$fmt=
					int22str(1). // AudioFormat: 1=PCM
					int22str(1). // NumChannels: 1=Mono
					int42str($sample_rate). // Samplerate
					int42str($sample_rate). // ByteRate = SampleRate * NumChannels * BitsPerSample/8
					int22str(1). // BlockAlign = NumChannels * BitsPerSample/8
					int22str(8). // BitsPerSample: 8
					"";
				$wav = make_chunk("RIFF", "WAVE" . make_chunk("fmt ", $fmt) . make_chunk("data", $wave_data));
				fwrite($fp, $wav);
				fclose($fp);
			}
		} else {
			die("Error: Unknown WAVE chunk type: " . $chunk_type);
		}
		$p += $chunk_size & 1; // padding
	}
}

function parse_MHWK($f) {
	$p = 0;
	$type = getstr($f,$p,4);
	switch ($type) {
		case "WAVE":
			parse_WAVE(substr($f,$p));
		break;
		case "MIDI":
			global $output_fn;
			$fp = fopen($output_fn.".mid","wb");
			fwrite($fp, substr($f,$p));
			fclose($fp);
		break;
		default:
			die("Error: Unknown MHWK chunk type: " . $chunk_type);
	}
}

$fn = $argv[1] or die("Error: Name of DAT file must be given in the command line.");
$f = file_get_contents($fn) or die("Error: Can't open file \"$fn\"");
mkdir("extracted");
$out_folder = "extracted/" . basename($fn);
mkdir($out_folder);

$p = 0x14;
$footer_addr = getint4mac($f,$p);
$p = $footer_addr;
$footer_offset = getint2mac($f,$p);
$p_footer = $footer_addr + $footer_offset;

$n_types = getint2mac($f,$p);
$p += 4;
$p += 2;
$p += 2;
$n_ids = getint2mac($f,$p);
$ids = array();
for ($i = 0; $i < $n_ids; $i++) {
	$id = getint2mac($f, $p);
	$index = getint2mac($f, $p);
	$ids[$index] = $id;
}

$n_resources = getint4mac($f,$p_footer);
for ($i = 0; $i < $n_resources; $i++) {
	$data_addr = getint4mac($f,$p_footer);
	$p_footer += 6;

	$p = $data_addr;

	$chunk_type = getstr($f,$p,4);
	$chunk_size = getint4mac($f,$p);
	if ($chunk_type !== "MHWK") die("Error: Resource is not in a MHWK chunk!");
	$chunk = getstr($f,$p,$chunk_size);
	$output_fn = sprintf("%s/res%05d", $out_folder, $ids[$i+1]);
	parse_MHWK($chunk);

	continue;
}
